//program Descomposicion LU
#include "mpi.h"
#include <stdlib.h>
#include <stdio.h>
#include <math.h>


#define N 3200
#define MIN (1.0E-20)

double A[N][N];
double suma[N];
double acumulador[N];
int main(int num_args, char* args[]){

int i,j,k,x,m,cont;
double s,ss;
int rank,p,p1,z;
int fila;

char msg[100];
int font;
int etiq = 0;
MPI_Status status;

//inicialitzacions MPI
MPI_Status estat;
MPI_Init(&num_args,&args);
MPI_Comm_rank(MPI_COMM_WORLD,&rank);
MPI_Comm_size(MPI_COMM_WORLD,&p);


// inicialitzacio de A
  for (i=0;i<N;i++)
    for (j=0;j<N;j++)
      A[i][j] = 1.0*(N-i)*(N-j)/(N*N);

        for (j=0;j<N;j++){
                if (A[j][j] == 0) A[j][j] = MIN;

                for (i=(rank+1);i<N;i+=p){
                        if (j<i){
                                A[i][j] /= A[j][j];
                                for (k=j+1;k<N;k++){
                                        A[i][k] -= A[i][j]*A[j][k];
                                }
                        }
                }

                fila=j%p;
                MPI_Bcast(A[j+1], N, MPI_DOUBLE, fila, MPI_COMM_WORLD);

        }

for (x=(N/p)*rank;x<=(N/p)*(rank+1);x++){
    acumulador[x] = 0;
    for (j=0; j<N; j++)
        acumulador[x-((N/p)*rank)] += A[x][j];
}

MPI_Gather(acumulador, (N/p), MPI_DOUBLE, suma, (N/p), MPI_DOUBLE, 0, MPI_COMM_WORLD);


if (rank==0){
    s = 0;
  for (i=0; i<N; i++)
   {
    s += suma[i];
   printf("  %lg \n ", suma[i]);
   }
 printf("Suma %lg \n ",s);
}

MPI_Finalize();

return (0);

}
